package com.jscape.inet.terminal.commands;

import com.jscape.inet.terminal.SpecialGraphic;
import com.jscape.inet.terminal.Terminal;

/**
 * SCS -- Select Character Set.
 * Sets Special Graphics character set to register G0.
 */
public class SCSG00Command
        implements ControlCommand {

    public static final String CANONICAL_FORM = "\033(0";
    private static final SCSG00Command INSTANCE = new SCSG00Command();

    //----------------------------------------------------------------------------

    /**
     * Returns one and only one instance of this type.
     *
     * @return one and only one instance of this type.
     */
    public static SCSG00Command getInstance() {
        return INSTANCE;
    }

    //----------------------------------------------------------------------------

    /**
     * Private constructor to prevent uncontrolled creation.
     */
    private SCSG00Command() {
    }

    //----------------------------------------------------------------------------

    /**
     * Executes command giving parameters and <code>Terminal</code> object.
     *
     * @param params   array of <code>int</code> command parametrs.
     * @param terminal target <code>Terminal</code> object.
     */
    public void execute(int[] params, Terminal terminal) {
        terminal.setG0(SpecialGraphic.getInstance());
    }

    //----------------------------------------------------------------------------

    /**
     * Sends command to remote host.
     *
     * @param params   command parameters.
     * @param terminal target <code>Terminal</code> object to send command.
     */
    public void send(int[] params, Terminal terminal) {
        terminal.send(CANONICAL_FORM);
    }

}
